var j = Object.defineProperty;
var Q = (o, s, t) => s in o ? j(o, s, { enumerable: !0, configurable: !0, writable: !0, value: t }) : o[s] = t;
var d = (o, s, t) => (Q(o, typeof s != "symbol" ? s + "" : s, t), t);
import { PlotController as H, CursorType as M, newScreenPoint as tt, OxyModifierKeys as I, OxyMouseButton as b, LineJoin as L, OxyColorHelper as c, FontWeights as F, newOxySize as K, ClippingRenderContext as W, round as R, isNullOrUndef as E, HorizontalAlignment as T, VerticalAlignment as S, StringHelper as $, OxyImageEx as et, newOxyRect as B, OxyRectHelper as z, OxyRect_Empty as N, OxyColors as G, EdgeRenderingMode as X, OxyColorEx as A, ScreenPoint_LeftTop as it, SvgRenderContext as st } from "oxyplot-js";
import { jsPDF as Z } from "jspdf";
class J {
  constructor() {
    d(this, "controller");
    d(this, "defaultController");
    d(this, "_zoomRectangle");
    d(this, "_model");
    d(this, "_isModelInvalidated", !1);
    d(this, "_updateDataFlag", !1);
    d(this, "_rendering", !1);
  }
  get actualController() {
    return this.controller ? this.controller : this.defaultController ? this.defaultController : (this.defaultController = new H(), this.defaultController);
  }
  get actualModel() {
    return this._model;
  }
  get model() {
    return this._model;
  }
  set model(s) {
    const t = this._model;
    this._model = s, this.onModelChanged(t, s);
  }
  onModelChanged(s, t) {
    s && s.attachPlotView(void 0), t && t.attachPlotView(this), this.invalidatePlot(!0);
  }
  invalidatePlot(s) {
    this._isModelInvalidated = !0, this._updateDataFlag = s || !1, this.render();
  }
  render() {
    const s = this._model;
    s && (this._isModelInvalidated && (s.update(this._updateDataFlag), this._isModelInvalidated = !1, this._updateDataFlag = !1), window.requestAnimationFrame(async () => this.renderSync()));
  }
  setClipboardText(s) {
    try {
      navigator.clipboard.writeText(s);
    } catch (t) {
      console.error(t);
    }
  }
  setCursorType(s) {
  }
  hideTracker() {
  }
  showTracker(s) {
  }
  hideZoomRectangle() {
    this._zoomRectangle = void 0;
  }
  showZoomRectangle(s) {
    this._zoomRectangle = s;
  }
  async renderSync() {
    if (this._model && !this._rendering) {
      this._rendering = !0;
      try {
        await this.renderOverride(this._model);
      } finally {
        this._rendering = !1;
      }
    }
  }
}
function P(o) {
  return {
    position: tt(o.offsetX, o.offsetY),
    modifierKeys: rt(o),
    handled: !1
  };
}
function nt(o) {
  const s = P(o);
  return s.clickCount = o.detail, s.changedButton = lt(o), s;
}
function ot(o) {
  const s = P(o);
  return s.delta = o.deltaY != 0 ? -o.deltaY : o.deltaX, s;
}
function rt(o) {
  let s = I.None;
  return o.ctrlKey && (s |= I.Control), o.shiftKey && (s |= I.Shift), o.altKey && (s |= I.Alt), o.metaKey && (s |= I.Windows), s;
}
function lt(o) {
  return o.button === 0 ? b.Left : o.button === 1 ? b.Middle : o.button === 2 ? b.Right : o.button === 3 ? b.XButton1 : o.button === 4 ? b.XButton2 : b.None;
}
function k(o) {
  switch (o) {
    case M.Default:
      return "default";
    case M.Pan:
      return "grab";
    case M.ZoomRectangle:
      return "nwse-resize";
    case M.ZoomHorizontal:
      return "ew-resize";
    case M.ZoomVertical:
      return "ns-resize";
    default:
      return "default";
  }
}
function q(o, s) {
  o.addEventListener("contextmenu", function(t) {
    t.preventDefault();
  }), new ResizeObserver(() => {
    s.invalidatePlot(!1);
  }).observe(o), o.onmousedown = (t) => {
    s.actualController.handleMouseDown(s, nt(t));
  }, o.onmousemove = (t) => {
    s.actualController.handleMouseMove(s, P(t));
  }, o.onmouseup = (t) => {
    s.actualController.handleMouseUp(s, P(t));
  }, o.onmouseenter = (t) => {
    s.actualController.handleMouseEnter(s, P(t));
  }, o.onmouseleave = (t) => {
    s.actualController.handleMouseLeave(s, P(t));
  }, o.onwheel = (t) => {
    s.actualController.handleMouseWheel(s, ot(t));
  };
}
let O = null;
function at() {
  if (O)
    return O;
  const o = document.createElement("canvas");
  if (O = o == null ? void 0 : o.getContext("2d"), !O)
    throw new Error("Could not get canvas context");
  return O;
}
let V = null;
const ht = (o, s, t) => (V || (V = new D()), V.convertFont(o, s, t || F.Normal));
function U(o) {
  o = o || at();
  function s(t, e, i, n) {
    if (!o)
      throw new Error("Could not get canvas context");
    o.font = ht(e, i, n);
    const r = o.measureText(t);
    return K(r.width, i);
  }
  return {
    measureText: s
  };
}
class D {
  convertLineJoin(s) {
    switch (s = s || L.Miter, s) {
      case L.Miter:
        return "miter";
      case L.Bevel:
        return "bevel";
      case L.Round:
        return "round";
    }
  }
  convertStrokeOrFillStyle(s) {
    return c.toRgba(s);
  }
  convertFont(s, t, e) {
    let i = "";
    return (e || F.Normal) > F.Normal && (i += "bold "), i += `${t || 12}px `, s && (i += `"${s}" `), i.trim();
  }
}
class ct {
  constructor() {
    d(this, "cache", /* @__PURE__ */ new Map());
  }
  get(s) {
    return this.cache.get(s);
  }
  set(s, t) {
    this.cache.set(s, t);
  }
  clear(s) {
    s ? this.cache.delete(s) : this.cache.clear();
  }
}
let Y = new ct();
function dt() {
  return Y;
}
function pt(o) {
  Y = o;
}
class ut extends W {
  constructor(t) {
    super();
    d(this, "ctx");
    d(this, "_textMeasurer");
    d(this, "styleConverter", new D());
    d(this, "_ctxInitStyles");
    d(this, "_renderContextImageCacheService");
    this.canvas = t;
    const e = t.getContext("2d");
    if (!e)
      throw new Error("Could not get canvas context");
    this.ctx = e, this._ctxInitStyles = {
      fillStyle: e.fillStyle,
      strokeStyle: e.strokeStyle,
      lineJoin: e.lineJoin,
      lineWidth: e.lineWidth
    }, this._renderContextImageCacheService = dt(), this._textMeasurer = U(e);
  }
  async drawImage(t, e, i, n, r, a, u, l, h, f, y) {
    if (f <= 0)
      return;
    this.resetStyles();
    const g = this.ctx, _ = await this.getOrCreateImage(t, () => {
      const w = new Blob([Uint8Array.from(t.data)], { type: "image/png" });
      return createImageBitmap(w);
    });
    g.imageSmoothingEnabled = y, g.drawImage(
      _,
      e,
      i,
      n,
      r,
      R(a, 0),
      R(u, 0),
      R(l, 0),
      R(h, 0)
    );
  }
  /**
   * Draws line segments.
   * @param points The points.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawLineSegments(t, e, i, n, r, a) {
    if (t.length < 2 || c.isInvisible(e) || i == 0)
      return;
    this.resetStyles();
    const u = this.ctx;
    u.beginPath(), this.applyLineStyle(e, i, n, r, a);
    for (let l = 0; l < t.length; l += 2) {
      const h = t[l], f = t[l + 1];
      this.drawPoints([h, f]);
    }
    u.stroke();
  }
  async drawLine(t, e, i, n, r, a) {
    if (t.length < 2 || c.isInvisible(e) || i == 0)
      return;
    this.resetStyles();
    const u = this.ctx;
    u.beginPath(), this.applyLineStyle(e, i, n, r, a), this.drawPoints(t), u.stroke();
  }
  /**
   * Draws a polygon.
   * @param points The points.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygon(t, e, i, n, r, a, u) {
    if (c.isInvisible(e) && !(c.isVisible(i) || n <= 0) || t.length < 2)
      return;
    this.resetStyles();
    const l = this.ctx;
    l.beginPath(), this.applyPolygonStyle(e, i, n, r, a, u), this.drawPoints(t), l.closePath(), c.isVisible(e) && l.fill(), c.isVisible(i) && n > 0 && l.stroke();
  }
  /**
   * Draws multiple polygons.
   * @param polygons The polygons.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygons(t, e, i, n, r, a, u) {
    if (c.isInvisible(e) && !(c.isVisible(i) || n <= 0) || t.length === 0)
      return;
    this.resetStyles();
    const l = this.ctx;
    this.applyPolygonStyle(e, i, n, r, a, u);
    for (const h of t)
      h.length < 2 || (l.beginPath(), this.drawPoints(h), l.closePath(), c.isVisible(e) && l.fill(), c.isVisible(i) && n > 0 && l.stroke());
  }
  /**
   * Draws the text.
   * @param p The position of the text.
   * @param text The text.
   * @param fill The fill color.
   * @param fontFamily The font family.
   * @param fontSize Size of the font.
   * @param fontWeight The font weight.
   * @param rotation The rotation angle.
   * @param horizontalAlignment The horizontal alignment.
   * @param verticalAlignment The vertical alignment.
   * @param maxSize The maximum size of the text.
   */
  async drawText(t, e, i, n, r, a, u, l, h, f) {
    if (!e || c.isInvisible(i))
      return;
    E(l) && (l = T.Left), E(h) && (h = S.Top), this.resetStyles();
    const y = this.ctx;
    r = r || 12, a = a || F.Normal, this.applyTextStyle(i, n, r, a), y.save(), y.translate(t.x, t.y), u && y.rotate(u * (Math.PI / 180));
    const g = $.splitLines(e), _ = [];
    for (const x of g) {
      const v = this.measureText(x, n, r, a);
      _.push(v);
    }
    const w = _.reduce((x, v) => x + v.height, 0);
    let p = 0;
    y.textBaseline = "middle", h === S.Top ? p = 0 : h === S.Middle ? p = -w / 2 : h === S.Bottom && (p = -w);
    for (let x = 0; x < g.length; x++) {
      const v = g[x];
      let m = 0;
      const C = _[x];
      l === T.Center ? m = -C.width / 2 : l === T.Right && (m = -C.width), y.fillText(v, m, p + C.height / 2, f == null ? void 0 : f.width), p += C.height;
    }
    y.restore();
  }
  measureText(t, e, i, n) {
    return this._textMeasurer.measureText(t, e, i, n);
  }
  setClip(t) {
    this.ctx.save();
    const e = new Path2D();
    e.rect(t.left, t.top, t.width, t.height), this.ctx.clip(e);
  }
  resetClip() {
    this.ctx.restore();
  }
  resetStyles() {
    const t = this.ctx;
    t.setLineDash([]), Object.assign(t, this._ctxInitStyles);
  }
  applyLineStyle(t, e, i, n, r) {
    const a = this.ctx;
    n && n.length > 0 && a.setLineDash(n), a.lineWidth = e, a.lineJoin = this.styleConverter.convertLineJoin(r), a.strokeStyle = this.styleConverter.convertStrokeOrFillStyle(t);
  }
  applyPolygonStyle(t, e, i, n, r, a) {
    c.isVisible(e) && i > 0 && this.applyLineStyle(e, i, n, r, a), c.isVisible(t) && (this.ctx.fillStyle = this.styleConverter.convertStrokeOrFillStyle(t));
  }
  applyTextStyle(t, e, i, n) {
    const r = this.ctx;
    r.fillStyle = this.styleConverter.convertStrokeOrFillStyle(t), r.font = this.styleConverter.convertFont(e, i, n);
  }
  drawPoints(t) {
    this.ctx.moveTo(t[0].x, t[0].y);
    for (let e = 1; e < t.length; e++) {
      const i = t[e];
      this.ctx.lineTo(i.x, i.y);
    }
  }
  async getOrCreateImage(t, e) {
    const i = et.from(t).getHashCode().toString(), n = this._renderContextImageCacheService.get(i);
    if (n)
      return Promise.resolve(n);
    const r = await e();
    return this._renderContextImageCacheService.set(i, r), r;
  }
}
class _t extends J {
  constructor(t) {
    super();
    d(this, "_view");
    d(this, "_tooltip");
    d(this, "_renderContext");
    d(this, "_drawCtx");
    d(this, "_styleConverter", new D());
    if (this._view = t, this.setupCanvas(t), this._drawCtx = this._view.getContext("2d"), !this._drawCtx)
      throw new Error("Could not get 2d context");
    this._tooltip = document.createElement("div"), this._tooltip.style.position = "absolute", this._tooltip.style.zIndex = "100", this._tooltip.style.backgroundColor = "#FFFFA0E0", this._tooltip.style.border = "1px solid black", this._tooltip.style.padding = "8px", this._tooltip.style.visibility = "hidden", this._tooltip.style.pointerEvents = "none", document.body.appendChild(this._tooltip), this._renderContext = new ut(this._view), q(this._view, this), new ResizeObserver(() => {
      this.setupCanvas(t);
    }).observe(t);
  }
  setupCanvas(t) {
    const e = window.devicePixelRatio || 1, i = t.getBoundingClientRect();
    i.width === 0 || i.height === 0 || (t.width = i.width * e, t.height = i.height * e);
  }
  get tooltip() {
    return this._tooltip;
  }
  get clientArea() {
    return B(0, 0, this._view.width, this._view.height);
  }
  hideTracker() {
    this._tooltip.style.visibility = "hidden";
  }
  showTracker(t) {
    if (!(t != null && t.position))
      return;
    const e = t.toString() || "";
    if (e.trim().length === 0)
      return;
    const { top: i, left: n } = this._view.getBoundingClientRect();
    this._tooltip.innerText = e, this._tooltip.style.top = `${i + t.position.y}px`, this._tooltip.style.left = `${n + t.position.x}px`, this._tooltip.style.visibility = "visible";
  }
  setCursorType(t) {
    this._view.style.cursor = k(t);
  }
  async renderOverride(t) {
    this._drawCtx = this._view.getContext("2d");
    const e = window.devicePixelRatio || 1;
    this._drawCtx.scale(e, e);
    const i = this._view;
    if (this._drawCtx.reset(), c.isUndefined(t.background) || (this._drawCtx.fillStyle = this._styleConverter.convertStrokeOrFillStyle(t.background), this._drawCtx.fillRect(0, 0, i.width, i.height)), await t.render(this._renderContext, B(0, 0, i.width, i.height)), this._zoomRectangle && z.equals(this._zoomRectangle, N)) {
      const n = c.parse("#40FFFF00"), r = G.Black;
      await this._renderContext.drawRectangle(this._zoomRectangle, n, r, 1, X.Automatic);
    }
  }
}
class yt extends W {
  constructor(t) {
    super();
    d(this, "_pdf");
    d(this, "ctx");
    d(this, "_textMeasurer");
    d(this, "styleConverter", new D());
    d(this, "_ctxInitStyles");
    this._pdf = new Z({
      unit: "px",
      orientation: t
    });
    const e = this._pdf.context2d;
    this.ctx = e, this._ctxInitStyles = {
      fillStyle: e.fillStyle,
      strokeStyle: e.strokeStyle,
      lineJoin: e.lineJoin,
      lineWidth: e.lineWidth
    }, this._textMeasurer = U();
  }
  getPdf() {
    return this._pdf;
  }
  async drawImage(t, e, i, n, r, a, u, l, h, f, y) {
    if (f <= 0)
      return;
    const g = a - e / n * l, _ = t.width / n * l, w = u - i / r * h, p = t.height / r * h;
    this.clearStyles(), this._pdf.addImage(Uint8Array.from(t.data), "PNG", g, w, _, p);
  }
  /**
   * Draws line segments.
   * @param points The points.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawLineSegments(t, e, i, n, r, a) {
    if (t.length < 2 || c.isInvisible(e) || i == 0)
      return;
    this.clearStyles();
    const u = this.ctx;
    u.beginPath(), this.applyLineStyle(e, i, n, r, a);
    for (let l = 0; l < t.length; l += 2) {
      const h = t[l], f = t[l + 1];
      this.drawPoints([h, f]);
    }
    u.stroke();
  }
  async drawLine(t, e, i, n, r, a) {
    if (t.length < 2 || c.isInvisible(e) || i == 0)
      return;
    this.clearStyles();
    const u = this.ctx;
    u.beginPath(), this.applyLineStyle(e, i, n, r, a), this.drawPoints(t), u.stroke();
  }
  /**
   * Draws a polygon.
   * @param points The points.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygon(t, e, i, n, r, a, u) {
    if (c.isInvisible(e) && !(c.isVisible(i) || n <= 0) || t.length < 2)
      return;
    this.clearStyles();
    const l = A.fromOxyColor(e), h = A.fromOxyColor(i), f = this.ctx;
    if (l.a < 255 || h.a < 255) {
      this._pdf.saveGraphicsState();
      let y = 1, g = 1;
      l.a < 255 && (y = l.a / 255), h.a < 255 && (g = h.a / 255), this._pdf.setGState(this._pdf.GState({ opacity: y, "stroke-opacity": g }));
    }
    f.beginPath(), this.applyPolygonStyle(e, i, n, r, a, u), this.drawPoints(t), f.closePath(), c.isVisible(e) && f.fill(), c.isVisible(i) && n > 0 && f.stroke(), (l.a < 255 || h.a < 255) && this._pdf.restoreGraphicsState();
  }
  /**
   * Draws multiple polygons.
   * @param polygons The polygons.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygons(t, e, i, n, r, a, u) {
    if (c.isInvisible(e) && !(c.isVisible(i) || n <= 0) || t.length === 0)
      return;
    this.clearStyles();
    const l = this.ctx;
    this.applyPolygonStyle(e, i, n, r, a, u);
    for (const h of t)
      h.length < 2 || (l.beginPath(), this.drawPoints(h), l.closePath(), c.isVisible(e) && l.fill(), c.isVisible(i) && n > 0 && l.stroke());
  }
  /**
   * Draws the text.
   * @param p The position of the text.
   * @param text The text.
   * @param fill The fill color.
   * @param fontFamily The font family.
   * @param fontSize Size of the font.
   * @param fontWeight The font weight.
   * @param rotation The rotation angle.
   * @param horizontalAlignment The horizontal alignment.
   * @param verticalAlignment The vertical alignment.
   * @param maxSize The maximum size of the text.
   */
  async drawText(t, e, i, n, r, a, u, l, h, f) {
    if (!e || c.isInvisible(i))
      return;
    this.clearStyles(), E(l) && (l = T.Left), E(h) && (h = S.Top);
    const y = this.ctx;
    r = r || 12, a = a || F.Normal, this.applyTextStyle(i, n, r, a), y.save(), y.translate(t.x, t.y), u && y.rotate(u * (Math.PI / 180));
    const g = $.splitLines(e), _ = [];
    for (const x of g) {
      const v = this.measureText(x, n, r, a);
      _.push(v);
    }
    const w = _.reduce((x, v) => x + v.height, 0);
    let p = 0;
    y.textBaseline = "middle", h === S.Top ? p = 0 : h === S.Middle ? p = -w / 2 : h === S.Bottom && (p = -w);
    for (let x = 0; x < g.length; x++) {
      const v = g[x];
      let m = 0;
      const C = _[x];
      l === T.Center ? m = -C.width / 2 : l === T.Right && (m = -C.width), y.fillText(v, m, p + C.height / 2), p += C.height;
    }
    y.restore();
  }
  measureText(t, e, i, n) {
    return this._textMeasurer.measureText(t, e, i, n);
  }
  setClip(t) {
    this.ctx.save(), this.ctx.rect(t.left, t.top, t.width, t.height), this.ctx.clip();
  }
  resetClip() {
    this.ctx.restore();
  }
  applyLineStyle(t, e, i, n, r) {
    const a = this.ctx;
    n && n.length > 0 && a.setLineDash(n), a.lineWidth = e, a.lineJoin = this.styleConverter.convertLineJoin(r), a.strokeStyle = this.styleConverter.convertStrokeOrFillStyle(t);
  }
  clearStyles() {
    this.ctx.setLineDash([]);
  }
  applyPolygonStyle(t, e, i, n, r, a) {
    c.isVisible(e) && i > 0 && this.applyLineStyle(e, i, n, r, a), c.isVisible(t) && (this.ctx.fillStyle = this.styleConverter.convertStrokeOrFillStyle(t));
  }
  applyTextStyle(t, e, i, n) {
    const r = this.ctx;
    r.fillStyle = this.styleConverter.convertStrokeOrFillStyle(t), r.font = this.styleConverter.convertFont(e, i, n);
  }
  drawPoints(t) {
    this.ctx.moveTo(t[0].x, t[0].y);
    for (let e = 1; e < t.length; e++) {
      const i = t[e];
      this.ctx.lineTo(i.x, i.y);
    }
  }
}
class vt extends J {
  constructor(t) {
    super();
    d(this, "_view");
    d(this, "_orientation", "portrait");
    d(this, "_clientArea", N);
    this._view = t, this.calcClientArea();
  }
  get orientation() {
    return this._orientation;
  }
  set orientation(t) {
    t !== this._orientation && (this._orientation = t, this.calcClientArea());
  }
  calcClientArea() {
    const t = new Z({
      unit: "px",
      orientation: this.orientation
    }), e = K(t.internal.pageSize.width, t.internal.pageSize.height);
    t.close(), this._clientArea = z.fromScreenPointAndSize(it, e);
  }
  get clientArea() {
    return this._clientArea;
  }
  async renderOverride(t) {
    const e = new yt(this.orientation);
    await t.render(e, this.clientArea);
    const i = e.getPdf();
    i.internal.pages.length > 1 && i.deletePage(1);
    const n = i.output("dataurlstring", {
      filename: t.title + ".pdf"
    });
    this._view.src = "", this._view.src = n;
  }
}
class wt extends J {
  constructor(t) {
    super();
    d(this, "_view");
    d(this, "_tooltip");
    //private readonly _drawCtx: HTMLElement
    d(this, "textMeasurer");
    this._view = t, this.textMeasurer = U(), this._tooltip = document.createElement("div"), this._tooltip.style.position = "absolute", this._tooltip.style.zIndex = "100", this._tooltip.style.backgroundColor = "#FFFFA0E0", this._tooltip.style.border = "1px solid black", this._tooltip.style.padding = "8px", this._tooltip.style.visibility = "hidden", this._tooltip.style.pointerEvents = "none", document.body.appendChild(this._tooltip), q(this._view, this);
  }
  get tooltip() {
    return this._tooltip;
  }
  get clientArea() {
    return B(0, 0, this._view.clientWidth, this._view.clientHeight);
  }
  hideTracker() {
    this._tooltip.style.visibility = "hidden";
  }
  showTracker(t) {
    if (!(t != null && t.position))
      return;
    const e = t.toString() || "";
    if (e.trim().length === 0)
      return;
    const i = this._view.offsetTop, n = this._view.offsetLeft;
    this._tooltip.innerText = e, this._tooltip.style.top = `${i + t.position.y}px`, this._tooltip.style.left = `${n + t.position.x}px`, this._tooltip.style.visibility = "visible";
  }
  setCursorType(t) {
    this._view.style.cursor = k(t);
  }
  async renderOverride(t) {
    const e = this._view;
    this._view.innerHTML = "";
    const i = new st(
      e.clientWidth,
      e.clientHeight,
      !0,
      this.textMeasurer,
      t.background
    );
    if (c.isUndefined(t.background) || (this._view.style.backgroundColor = t.background.toString()), await t.render(i, B(0, 0, e.clientWidth, e.clientHeight)), this._zoomRectangle && z.equals(this._zoomRectangle, N)) {
      const n = c.parse("#40FFFF00"), r = G.Black;
      await i.drawRectangle(this._zoomRectangle, n, r, 1, X.Automatic);
    }
    i.complete(), this._view.innerHTML = i.getXml();
  }
}
export {
  _t as CanvasPlotView,
  vt as PdfPlotView,
  wt as SvgPlotView,
  dt as getRenderContextImageCacheService,
  pt as setRenderContextImageCacheService
};
